<?php
/*
Plugin Name: Paul Hot Keys
Plugin URI: http://www.paolocantoni.com/hot-keys
Description: This plugin show you the most used keys of your keyboard
Author: Paolo Cantoni
Version: 1.0
Author URI: http://www.paolocantoni.com

Copyright 2007 Paolo Cantoni (email : paul@paolocantoni.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


//carico il file di configurazione per aggiungere le azioni
if (!function_exists('add_action')) require_once('../../../wp-config.php');

//carico il file css
add_action('wp_head', 'paul_hot_key_header');

function paul_hot_key_header() {
  echo "\n<link rel='stylesheet' href='".get_option('siteurl')."/wp-content/plugins/paul_hot_key/paul_hot_key.css' type='text/css' media='screen' />\n";
  echo "<script type='text/javascript' src='".get_option('siteurl')."/wp-content/plugins/paul_hot_key/jquery-1.2.3.min.js'></script>\n";
?>
<script type="text/javascript">
$(document).ready(function(){
	$('a.paulHotKeyLink').click(function(){
    var id = this.id.split("_");
    $('div#paulHotKey_'+id[1]).slideToggle("slow");
  });
});
</script>
<?php  
}

function paul_hot_key(){
  global $post;
	if(!is_feed()) 
  {
    $tasti = array(
      "shift" =>    array(124,33,34,163,36,37,38,47,40,41,61,63,94,233,42,231,176,167,62,59,58,95),// | ! "  $ % & / ( ) = ? ^  *    > ; : _
      "tab" =>      array(9),// tab
      "alt" =>      array(91,93,64,35),// [ ] @ #
      "shiftalt" => array(123,125) // { }
    );
    
    //inizializzo le variabili
    $alt = $shift = $maiusc = $max = 0; 
    for($i=1;$i<256;$i++)
      $tastiera[$i] = 0;
    
    $testo = $post->post_content;

    $num = strlen($testo);
    
    //riempio l'array con il numero di occorrenze della lettera
    for($i=0;$i<$num;$i++)
      $tastiera[ord($testo{$i})]++;
    
    //maggioro i tasti con lettere multiple es   @
    for($i=1;$i<256;$i++)
    {
      if(in_array($i,$tasti["shift"]))
      {
        $shift += $tastiera[$i];
        if($i==124) $tastiera[92]  += $tastiera[$i];// |
        if($i==33)  $tastiera[49]  += $tastiera[$i];// !
        if($i==34)  $tastiera[50]  += $tastiera[$i];// "
        if($i==163) $tastiera[51]  += $tastiera[$i];// 
        if($i==36)  $tastiera[52]  += $tastiera[$i];// $
        if($i==37)  $tastiera[53]  += $tastiera[$i];// %
        if($i==38)  $tastiera[54]  += $tastiera[$i];// &
        if($i==47)  $tastiera[55]  += $tastiera[$i];// /
        if($i==40)  $tastiera[56]  += $tastiera[$i];// (
        if($i==41)  $tastiera[57]  += $tastiera[$i];// )
        if($i==61)  $tastiera[48]  += $tastiera[$i];// =
        if($i==63)  $tastiera[39]  += $tastiera[$i];// ?
        if($i==94)  $tastiera[236] += $tastiera[$i];// ^
        if($i==233) $tastiera[232] += $tastiera[$i];// 
        if($i==42)  $tastiera[43]  += $tastiera[$i];// *
        if($i==231) $tastiera[242] += $tastiera[$i];// 
        if($i==176) $tastiera[224] += $tastiera[$i];// 
        if($i==167) $tastiera[249] += $tastiera[$i];// 
        if($i==62)  $tastiera[60]  += $tastiera[$i];// >
        if($i==59)  $tastiera[44]  += $tastiera[$i];// :
        if($i==58)  $tastiera[46]  += $tastiera[$i];// ;
        if($i==95)  $tastiera[45]  += $tastiera[$i];// _
      }
      elseif(in_array($i,$tasti["tab"])) $alt += $tastiera[$i];
      elseif(in_array($i,$tasti["alt"])) 
      {
        $alt += $tastiera[$i];
        if($i==91) $tastiera[232] += $tastiera[$i];// [
        if($i==93) $tastiera[43]  += $tastiera[$i];// ]
        if($i==64) $tastiera[242] += $tastiera[$i];// @
        if($i==35) $tastiera[224] += $tastiera[$i];// #
      }
      elseif(in_array($i,$tasti["shiftalt"]))
      {
        $shift += $tastiera[$i];
        $alt += $tastiera[$i];
        if($i==123) $tastiera[232] += $tastiera[$i];// {
        if($i==125) $tastiera[43]  += $tastiera[$i];// }
      }
      elseif($i>=65 && $i<=90)
      {
        $tastiera[$i+32] += $tastiera[$i];
        $shift += $tastiera[$i];
      }
    }
    $return = $tastiera[10];
    
    //cerco il valore massimo per normalizzare i dati
    for($i=1;$i<256;$i++)
      if($max < $tastiera[$i])
        $max = $tastiera[$i];
    
    if($max < $alt) $max = $alt;
    if($max < $shift) $max = $shift;
    if($max < $return) $max = $return;

    $phk = "<a id='paulHotKeyLink_".$post->ID."' class='paulHotKeyLink'>Mostra/Nascondi tastiera HotKeys</a>";
    $phk.= "<div id='paulHotKey_".$post->ID."' class='paulHotKey'>";
    $phk.= "<div class='c".round($tastiera[ord("|")]/$max*100,-1)."'><span>|</span><br/><span>\</span></div>";
    $phk.= "<div class='c".round($tastiera[ord("!")]/$max*100,-1)."'><span>!</span><br/><span>1</span></div>";
    $phk.= "<div class='c".round($tastiera[ord("\"")]/$max*100,-1)."'><span>\"</span><br/><span>2</span></div>";
    $phk.= "<div class='c".round($tastiera[ord("")]/$max*100,-1)."'><span>&#321;</span><br/><span>3</span></div>";
    $phk.= "<div class='c".round($tastiera[ord("$")]/$max*100,-1)."'><span>$</span><br/><span>4</span></div>";
    $phk.= "<div class='c".round($tastiera[ord("%")]/$max*100,-1)."'><span>%</span><br/><span>5</span></div>";
    $phk.= "<div class='c".round($tastiera[ord("&")]/$max*100,-1)."'><span>&amp;</span><br/><span>6</span></div>";
    $phk.= "<div class='c".round($tastiera[ord("/")]/$max*100,-1)."'><span>/</span><br/><span>7</span></div>";
    $phk.= "<div class='c".round($tastiera[ord("(")]/$max*100,-1)."'><span>(</span><br/><span>8</span></div>";
    $phk.= "<div class='c".round($tastiera[ord(")")]/$max*100,-1)."'><span>)</span><br/><span>9</span></div>";
    $phk.= "<div class='c".round($tastiera[ord("=")]/$max*100,-1)."'><span>=</span><br/><span>0</span></div>";
    $phk.= "<div class='c".round($tastiera[ord("'")]/$max*100,-1)."'><span>?</span><br/><span>'</span></div>";
    $phk.= "<div class='c".round($tastiera[ord("^")]/$max*100,-1)."'><span>&circ;</span><br/><span>&igrave;</span></div>";
    $phk.= "<div class='back c".round($tastiera[ord("\t")]/$max*100,-1)."'><small>back</small></div>";
    $phk.= "<br/>";
    $phk.= "<div class='tab c".round($tab/$max*100,-1)."'><small>tab</small></div>";
    $phk.= "<div class='c".round($tastiera[ord("q")]/$max*100,-1)."'>Q</div>";
    $phk.= "<div class='c".round($tastiera[ord("w")]/$max*100,-1)."'>W</div>";
    $phk.= "<div class='c".round($tastiera[ord("e")]/$max*100,-1)."'>E</div>";
    $phk.= "<div class='c".round($tastiera[ord("r")]/$max*100,-1)."'>R</div>";
    $phk.= "<div class='c".round($tastiera[ord("t")]/$max*100,-1)."'>T</div>";
    $phk.= "<div class='c".round($tastiera[ord("y")]/$max*100,-1)."'>Y</div>";
    $phk.= "<div class='c".round($tastiera[ord("u")]/$max*100,-1)."'>U</div>";
    $phk.= "<div class='c".round($tastiera[ord("i")]/$max*100,-1)."'>I</div>";
    $phk.= "<div class='c".round($tastiera[ord("o")]/$max*100,-1)."'>O</div>";
    $phk.= "<div class='c".round($tastiera[ord("p")]/$max*100,-1)."'>P</div>";
    $phk.= "<div class='c".round($tastiera[ord("")]/$max*100,-1)."'><span>&eacute;</span><br/><span>&egrave;&nbsp;[</span></div>";
    $phk.= "<div class='c".round($tastiera[ord("+")]/$max*100,-1)."'><span>*</span><br/><span>+&nbsp;]</span></div>";
    $phk.= "<div class='returnt c".round($return/$max*100,-1)."'><small>enter</small></div>";
    $phk.= "<br/>";
    $phk.= "<div class='maiusc c".round($maiusc/$max*100,-1)."'><small>caps l.</small></div>";
    $phk.= "<div class='c".round($tastiera[ord("a")]/$max*100,-1)."'>A</div>";
    $phk.= "<div class='c".round($tastiera[ord("s")]/$max*100,-1)."'>S</div>";
    $phk.= "<div class='c".round($tastiera[ord("d")]/$max*100,-1)."'>D</div>";
    $phk.= "<div class='c".round($tastiera[ord("f")]/$max*100,-1)."'>F</div>";
    $phk.= "<div class='c".round($tastiera[ord("g")]/$max*100,-1)."'>G</div>";
    $phk.= "<div class='c".round($tastiera[ord("h")]/$max*100,-1)."'>H</div>";
    $phk.= "<div class='c".round($tastiera[ord("j")]/$max*100,-1)."'>J</div>";
    $phk.= "<div class='c".round($tastiera[ord("k")]/$max*100,-1)."'>K</div>";
    $phk.= "<div class='c".round($tastiera[ord("l")]/$max*100,-1)."'>L</div>";
    $phk.= "<div class='c".round($tastiera[ord("")]/$max*100,-1)."'><span>&ccedil;</span><br/><span>&ograve;@</span></div>";
    $phk.= "<div class='c".round($tastiera[ord("")]/$max*100,-1)."'><span>&deg;</span><br/><span>&agrave;&nbsp;#</span></div>";
    $phk.= "<div class='c".round($tastiera[ord("")]/$max*100,-1)."'><span>&sect;</span><br/><span>&ugrave;</span></div>";
    $phk.= "<div class='returnb c".round($return/$max*100,-1)."'></div>";
    $phk.= "<br/>";
    $phk.= "<div class='shiftl c".round($shift/$max*100,-1)."'><small>shift</small></div>";
    $phk.= "<div class='c".round($tastiera[ord("<")]/$max*100,-1)."'><span>></span><br/><span><</span></div>";
    $phk.= "<div class='c".round($tastiera[ord("z")]/$max*100,-1)."'>Z</div>";
    $phk.= "<div class='c".round($tastiera[ord("x")]/$max*100,-1)."'>X</div>";
    $phk.= "<div class='c".round($tastiera[ord("c")]/$max*100,-1)."'>C</div>";
    $phk.= "<div class='c".round($tastiera[ord("v")]/$max*100,-1)."'>V</div>";
    $phk.= "<div class='c".round($tastiera[ord("b")]/$max*100,-1)."'>B</div>";
    $phk.= "<div class='c".round($tastiera[ord("n")]/$max*100,-1)."'>N</div>";
    $phk.= "<div class='c".round($tastiera[ord("m")]/$max*100,-1)."'>M</div>";
    $phk.= "<div class='c".round($tastiera[ord(",")]/$max*100,-1)."'><span>;</span><br/><span>,</span></div>";
    $phk.= "<div class='c".round($tastiera[ord(".")]/$max*100,-1)."'><span>:</span><br/><span>.</span></div>";
    $phk.= "<div class='c".round($tastiera[ord("-")]/$max*100,-1)."'><span>_</span><br/><span>-</span></div>";
    $phk.= "<div class='shiftr c".round($shift/$max*100,-1)."'><small>shift</small></div>";
    $phk.= "<br/>";
    $phk.= "<div class='ctrl'><small>ctrl</small></div>";
    $phk.= "<div class='win'><small>win</small></div>";
    $phk.= "<div class='alt'><small>alt</small></div>";
    $phk.= "<div class='space c".round($tastiera[32]/$max*100,-1)."'></div>";
    $phk.= "<div class='alt c".round($alt/$max*100,-1)."'><small>altGr</small></div>";
    $phk.= "<div class='win'><small>win</small></div>";
    $phk.= "<div class='win'></div>";
    $phk.= "<div class='ctrl'><small>ctrl</small></div>";
    $phk.= "<br />";
    $phk.= "<p class='paulLegend'>Legenda:<br/>";
    for($i=1;$i<=10;$i++)
      $phk.= "<label class='c".($i*10)."'>".($i*10)."%</label> ";
    $phk.= "<br />";
    $phk.= "</p>";
    $phk.= "</div>";
    $phk.= "<br />";
    
    return $phk;
	}
}

add_filter('the_content', 'paul_hot_key_place', '7');
//add_filter('the_excerpt', 'paul_hot_key_place', '7');
function paul_hot_key_place($content){
	if(!is_feed())
    return $content."<br/>".paul_hot_key();
}

?>